<?php

namespace Drupal\download_file\Controller;

use Drupal\Core\Controller\ControllerBase;
use Symfony\Component\HttpFoundation\BinaryFileResponse;
use Drupal\file\Entity\File;

/**
 * Download File controller.
 */
class DownloadFileController extends ControllerBase {

  /**
   * Page callback; Direct download of the given file.
   */
  public function downloadFileDirectDownload($file_id = NULL) {
    $file = File::load($file_id);
    $default_headers = file_get_content_headers($file);
    $custom_headers = [
      'Content-Type' => 'application/octet-stream',
      'Content-Disposition' => 'attachment; filename="' . $file->getFilename() . '"',
      'Content-Length' => $file->getSize(),
      'Content-Transfer-Encoding' => 'binary',
      'Pragma' => 'no-cache',
      'Cache-Control' => 'must-revalidate, post-check=0, pre-check=0',
      'Expires' => '0',
      'Accept-Ranges' => 'bytes',
    ];
    $headers = array_merge($default_headers, $custom_headers);
    return new BinaryFileResponse($file->getFileUri(), 200, $headers);
  }

}
